const { SlashCommandBuilder } = require('@discordjs/builders');
const fs = require('fs');
const config = require('../config.json')
const { Modal, TextInputComponent } = require('discord-modals');

module.exports = {
    data: new SlashCommandBuilder()
    .setName("addstock")
    .setDescription("เพิ่มสต็อคของ")
    .addStringOption(option =>
        option
        .setName("id")
        .setDescription("ไอดีของ")
        .setRequired(true)
    ),
    async execute(client, interaction) {
        if(!config.ownerid.includes(interaction.user.id)) return await interaction.reply({ content: "คุณไม่มีสิทธิ์ใช้คำสั่งนี้", ephemeral: true });
        const stockdata = JSON.parse(fs.readFileSync('./db/item.json', 'utf8'));
        const id = interaction.options.getString("id");
        if(!stockdata[id]) return await interaction.reply({ content: `\`❌\` \`|\` ไม่มีสต็อคไอดีนี้ **${id}** `,ephemeral: true });
        if(stockdata[id].type != 'any') return await interaction.reply({ content: `\`❌\` \`|\` ไม่สามารถใช้กับของประเภท ขายของแค่อย่างเดียว **${id}** `,ephemeral: true });
        const addstockitem = new Modal()
              .setCustomId(`addstock-item|${id}`)
              .setTitle('เพิ่มสต๊อกสินค้า')
              .addComponents(
                new TextInputComponent()
                .setCustomId('addstock-item-any')
                .setLabel('สินค้าที่จะเพิ่ม')
                .setPlaceholder('กรอกสินค้าที่ต้องการขาย ( 1 บรรทัดต่อ 1 ชิ้น)')
                .setStyle("PARAGRAPH")
                .setRequired(true),
                )
        
        await interaction.showModal(addstockitem)
    }
}