const { SlashCommandBuilder } = require('@discordjs/builders');
const fs = require('fs');
const config = require('../config.json')
const { Modal, TextInputComponent } = require('discord-modals');

module.exports = {
    data: new SlashCommandBuilder()
    .setName("edit")
    .setDescription("แก้ไขสินค้า")
    .addStringOption(option =>
        option
        .setName("id")
        .setDescription("ไอดีของ")
        .setRequired(true)
    ),
    async execute(client, interaction) {
        if(!config.ownerid.includes(interaction.user.id)) return await interaction.reply({ content: "คุณไม่มีสิทธิ์ใช้คำสั่งนี้", ephemeral: true });
        const stockdata = JSON.parse(fs.readFileSync('./db/item.json', 'utf8'));
        const id = interaction.options.getString("id");
        const type = stockdata[id].type
        if(!stockdata[id]) return await interaction.reply({ content: `\`❌\` \`|\` ไม่มีสต็อคไอดีนี้ **${id}** `,ephemeral: true });
        const edititem_only = new Modal()
              .setCustomId(`edit-modal-only|${id}`)
              .setTitle('แก้ไขสินค้า | ถ้าไม่แก้ก็ห้าม (only)')
              .addComponents(
                new TextInputComponent()
                .setCustomId('edit-name-only')
                .setLabel('แก้ไขชื่อสินค้า')
                .setDefaultValue(stockdata[id].name.toString())
                .setStyle("SHORT")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('edit-description-only')
                .setLabel('แก้ไขรายละเอียดสินค้า')
                .setDefaultValue(stockdata[id].description.toString())
                .setStyle("PARAGRAPH")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('edit-price-only')
                .setLabel('แก้ไขราคาสินค้า')
                .setDefaultValue(stockdata[id].price.toString())
                .setStyle("SHORT")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('edit-image-only')
                .setLabel('แก้ไขรูปภาพสินค้า')
                .setDefaultValue(stockdata[id].image.toString())
                .setStyle("SHORT")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('edit-url-only')
                .setLabel('แก้ไขสินค้าที่ต้องการขาย')
                .setDefaultValue(stockdata[id].url.toString())
                .setStyle("SHORT")
                .setRequired(true),
                );

        const edititem_any = new Modal()
            .setCustomId(`edit-modal-any|${id}`)
            .setTitle('แก้ไขสินค้า | ถ้าไม่แก้ก็ห้าม (any)')
            .addComponents(
                new TextInputComponent()
                .setCustomId('edit-name-any')
                .setLabel('แก้ไขชื่อสินค้า')
                .setDefaultValue(stockdata[id].name.toString())
                .setStyle("SHORT")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('edit-description-any')
                .setLabel('แก้ไขรายละเอียดสินค้า')
                .setDefaultValue(stockdata[id].description.toString())
                .setStyle("PARAGRAPH")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('edit-price-any')
                .setLabel('แก้ไขราคาสินค้า')
                .setDefaultValue(stockdata[id].price.toString())
                .setStyle("SHORT")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('edit-image-any')
                .setLabel('แก้ไขรูปภาพสินค้า')
                .setDefaultValue(stockdata[id].image.toString())
                .setStyle("SHORT")
                .setRequired(true),
            )
            if (type == 'only') {
                await interaction.showModal(edititem_only)
              }
            if (type == 'any') {
                await interaction.showModal(edititem_any)
              }
    }
}