const { SlashCommandBuilder } = require('@discordjs/builders');
const { Modal, TextInputComponent } = require('discord-modals');
const fs = require('fs');
const config = require('../config.json')

module.exports = {
    data: new SlashCommandBuilder()
    .setName("item")
    .setDescription("จัดการสินค้า")
    .addSubcommand(subcommand =>
        subcommand
        .setName("add")
        .setDescription("เพิ่มสินค้า")
        .addStringOption(option =>
            option.setName('type')
                .setDescription('ประเภทของ')
                .setRequired(true)
                .addChoices(
                    { name: 'ขายของแค่อย่างเดียว', value: 'Only' },
                    { name: 'ขายของหลายอย่าง', value: 'Any' },
                )
                .addChoices())
    )
    .addSubcommand(subcommand =>
        subcommand
        .setName("remove")
        .setDescription("ลบสินค้า")
        .addStringOption(option =>
            option
            .setName("id")
            .setDescription("ไอดีสินค้า")
            .setRequired(true)
        )
       
    ),
    async execute(client, interaction) {
        const type = interaction.options.getString("type");
        if(!config.ownerid.includes(interaction.user.id)) return interaction.reply({ content: "คุณไม่มีสิทธิ์ใช้คำสั่งนี้", ephemeral: true });
        if(interaction.options.getSubcommand() === "add") {
            const addstockmodal_only = new Modal()
            .setCustomId('addstock-id-only')
            .setTitle('เพิ่มสินค้า')
            .addComponents(
              new TextInputComponent()
              .setCustomId('addstock-name-only')
              .setLabel('ชื่อสินค้า')
              .setPlaceholder('กรอกชื่อสินค้า')
              .setStyle("SHORT")
              .setRequired(true),
              new TextInputComponent()
              .setCustomId('addstock-description-only')
              .setLabel('รายละเอียดสินค้า')
              .setPlaceholder('กรอกรายละเอียดสินค้า')
              .setStyle("PARAGRAPH")
              .setRequired(true),
              new TextInputComponent()
              .setCustomId('addstock-price-only')
              .setLabel('ราคาสินค้า')
              .setPlaceholder('กรอกราคาสินค้า')
              .setStyle("SHORT")
              .setRequired(true),
              new TextInputComponent()
              .setCustomId('addstock-image-only')
              .setLabel('รูปภาพสินค้า | ลิงก์รูปภาพ')
              .setPlaceholder('กรอกลิงก์รูปภาพ')
              .setStyle("SHORT")
              .setRequired(true),
              new TextInputComponent()
              .setCustomId('addstock-url-only')
              .setLabel('สินค้าที่ต้องการขาย')
              .setPlaceholder('กรอกสินค้าที่ต้องการขาย')
              .setStyle("SHORT")
              .setRequired(true),
              );

            const addstockmodal_any = new Modal()
              .setCustomId('addstock-id-any')
              .setTitle('เพิ่มสินค้า')
              .addComponents(
                new TextInputComponent()
                .setCustomId('addstock-name-any')
                .setLabel('ชื่อสินค้า')
                .setPlaceholder('กรอกชื่อสินค้า')
                .setStyle("SHORT")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('addstock-description-any')
                .setLabel('รายละเอียดสินค้า')
                .setPlaceholder('กรอกรายละเอียดสินค้า')
                .setStyle("PARAGRAPH")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('addstock-price-any')
                .setLabel('ราคาสินค้า')
                .setPlaceholder('กรอกราคาสินค้า')
                .setStyle("SHORT")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('addstock-image-any')
                .setLabel('รูปภาพสินค้า | ลิงก์รูปภาพ')
                .setPlaceholder('กรอกลิงก์รูปภาพ')
                .setStyle("SHORT")
                .setRequired(true),
                new TextInputComponent()
                .setCustomId('addstock-url-any')
                .setLabel('สินค้าที่ต้องการขาย')
                .setPlaceholder('กรอกสินค้าที่ต้องการขาย ( 1 บรรทัดต่อ 1 ชิ้น)')
                .setStyle("PARAGRAPH")
                .setRequired(true),
                );

          if (type == 'Only') {
            await interaction.showModal(addstockmodal_only)
          }
          if (type == 'Any') {
            await interaction.showModal(addstockmodal_any)
          }
        } else if(interaction.options.getSubcommand() === "remove") {
            const stockdata = JSON.parse(fs.readFileSync('./db/item.json', 'utf8'));
            const id = interaction.options.getString('id');
            if(!stockdata[id]) return interaction.reply({ content: `\`❌\` \`:\` \`ไม่พบสินค้าที่ต้องการลบ\``, ephemeral: true });
            const channel = interaction.guild.channels.cache.get(stockdata[id].channel_id);
            channel.delete();
            delete stockdata[id];
            fs.writeFileSync('./db/item.json', JSON.stringify(stockdata, null, '\t'));
            interaction.reply({ content: `\`✅\` \`:\` \`ทำการลบสินค้า ID\` \`:\` \`${id}\``, ephemeral: true })
        }
    }
  }