const { MessageEmbed } = require('discord.js');
const { SlashCommandBuilder } = require('@discordjs/builders');
const fs = require('fs');
const config = require('../config.json')

module.exports = {
    data: new SlashCommandBuilder()
    .setName("profile")
    .setDescription("view profile")
    .addUserOption(option =>
        option
        .setName("user")
        .setDescription("User")
        .setRequired(true)
    ),
    async execute(client, interaction) {
        const user = interaction.options.getUser("user");
        if(!config.ownerid.includes(interaction.user.id)) return interaction.reply({ content: "คุณไม่มีสิทธิ์ใช้คำสั่งนี้",ephemeral: true });
        const accdata = JSON.parse(fs.readFileSync('./db/acc.json', 'utf8'));
        if(!accdata[user.id]) return interaction.reply({ content: `<@${user.id}> ไม่มีบัญชี`,ephemeral: true });
        const embed = new MessageEmbed()
        .setColor("#00ff00")
        .setTitle(`ข้อมูลสมาชิก ${user.tag}`)
        .addFields(
            {
                name: "ยอดเงินคงเหลือ",
                value: `\`${accdata[user.id].point}\` บาท`,
            },
            {
                name: "ยอดเติมเงินสะสม",
                value: `\`${accdata[user.id].pointall}\` บาท`,
            }
        )
        .setFooter({ text: `${interaction.user.tag}`})
        .setThumbnail(user.avatarURL())
        
        interaction.reply({ embeds: [embed],ephemeral: true });
    }
}