const client = require("../index");
const { MessageEmbed, WebhookClient } = require("discord.js");
const fs = require('fs');
const config = require('../config.json')
const webhook = new WebhookClient({ url: config.webhook });

client.on('interactionCreate', async interaction => {
    if (!interaction.isButton()) return
    if (interaction.customId != 'buy') return
    await interaction.deferReply({ ephemeral: true });
    const id = interaction.message.embeds[0].footer.text.split(' : ')[1]
    const stockdata = JSON.parse(fs.readFileSync('./db/item.json', 'utf8'));
    const accdata = JSON.parse(fs.readFileSync('./db/acc.json', 'utf8'));
    if (!accdata[interaction.user.id]) return await interaction.editReply({ embeds: [new MessageEmbed().setColor(0xFF0000).setDescription('\`\`\`\nคุณยังไม่มีบัญชีกรุณาเติมเงินก่อน\n\`\`\`')], ephemeral: true })
    if (accdata[interaction.user.id].point < stockdata[id].price) return await interaction.editReply({ embeds: [new MessageEmbed().setColor(0xFF0000).setTitle(`เงินของคุณไม่เพียงพอคุณมีเงิน ${accdata[interaction.user.id].point} บาท (ขาดเงินอีก ${stockdata[id].price - accdata[interaction.user.id].point} บาท)`)], ephemeral: true })
    if (stockdata[id].type == 'only') {
        accdata[interaction.user.id].point -= stockdata[id].price
        fs.writeFileSync('./db/acc.json', JSON.stringify(accdata, null, 4));

        const dm = new MessageEmbed()
            .setColor("GREEN")
            .setTitle(`สั้งซื้อสินค้า ${id} สำเร็จ`)
            .setDescription(`\`\`\`สินค้าชื่อ : ${stockdata[id].name}\n\`\`\` \nลิงก์สินค้า\n\`\`\`${stockdata[id].url}\n\`\`\``)
            .setImage(stockdata[id].image)
            .setFooter({ text: `${interaction.user.tag}` })
        const succesbuy = new MessageEmbed()
            .setColor("GREEN")
            .setTitle("ซื้อสินค้าสำเร็จ")
            .setDescription(`\`\`\`yaml\nซื้อสินค้าเรียบร้อย โปรดเช็คในแชทส่วนตัว\n\`\`\``)
            .setFooter({ text: `${interaction.user.tag}` })

        const log = new MessageEmbed()
            .setColor("#3088ce")
            .setTitle("มีคนซื้อสินค้า")
            .setDescription(`<@${interaction.user.id}> \n\`\`\`ซื้อสินค้าชื่อ ${stockdata[id].name} (${id})\`\`\``)
            .addFields(
                { name: 'ราคา', value: `\`\`\`yaml\n${stockdata[id].price}\n\`\`\``, inline: true },
                { name: 'สินค้า', value: `\`\`\`\n${stockdata[id].url}\n\`\`\``, inline: true },
            )
            .setTimestamp()

        await webhook.send({ username: `${interaction.user.tag}`, embeds: [log], });
        await interaction.user.send({ embeds: [dm] })
        await interaction.editReply({ embeds: [succesbuy], ephemeral: true })

    } if (stockdata[id].type == 'any') {
        if (stockdata[id].amount == 0) return await interaction.editReply({ embeds: [new MessageEmbed().setColor(0xFF0000).setTitle('สินค้าในสต็อกของหมด')], ephemeral: true })

        accdata[interaction.user.id].point -= stockdata[id].price
        fs.writeFileSync('./db/acc.json', JSON.stringify(accdata, null, 4));

        const dm = new MessageEmbed()
            .setColor("GREEN")
            .setTitle(`สั้งซื้อสินค้า ${id} สำเร็จ`)
            .setDescription(`\`\`\`สินค้าชื่อ : ${stockdata[id].name}\n\`\`\` \nสินค้า\n\`\`\`${stockdata[id].url[0]}\n\`\`\``)
            .setImage(stockdata[id].image)
            .setFooter({ text: `${interaction.user.tag}` })
        const succesbuy = new MessageEmbed()
            .setColor("GREEN")
            .setTitle("ซื้อสินค้าสำเร็จ")
            .setDescription(`\`\`\`yaml\nซื้อสินค้าเรียบร้อย โปรดเช็คในแชทส่วนตัว\n\`\`\``)
            .setFooter({ text: `${interaction.user.tag}` })

        const log = new MessageEmbed()
            .setColor("#3088ce")
            .setTitle("มีคนซื้อสินค้า")
            .setDescription(`<@${interaction.user.id}> \n\`\`\`ซื้อสินค้าชื่อ ${stockdata[id].name} (${id})\`\`\`\n`)
            .addFields(
                { name: 'ราคา', value: `\`\`\`yaml\n${stockdata[id].price}\n\`\`\``, inline: true },
                { name: 'สินค้า', value: `\`\`\`\n${stockdata[id].url[0]}\n\`\`\``, inline: true },
            )
            .setTimestamp()

        stockdata[id].url.shift()
        stockdata[id].amount -= 1
        fs.writeFileSync('./db/item.json', JSON.stringify(stockdata, null, '\t'));
        await webhook.send({ username: `${interaction.user.tag}`, embeds: [log], });
        await interaction.user.send({ embeds: [dm] })
        await interaction.editReply({ embeds: [succesbuy], ephemeral: true })
        const embed = new MessageEmbed()
            .setTitle(`${stockdata[id].name} (ราคา ${stockdata[id].price}) คงเหลือ ${stockdata[id].amount}`)
            .setDescription(stockdata[id].description)
            .setImage(stockdata[id].image)
            .setFooter({ text: `ID : ${id}` })

        interaction.message.edit({ embeds: [embed] })

    }
})
