const client = require("../index");
const tw = require('@fortune-inc/tw-voucher');
const { MessageEmbed , WebhookClient} = require("discord.js");
const { Modal, TextInputComponent } = require('discord-modals');
const fs = require('fs');
const config = require('../config.json')
const webhook = new WebhookClient({ url: config.webhook });

client.on('interactionCreate', async interaction=> {
    accdata = JSON.parse(fs.readFileSync('./db/acc.json', 'utf8'));
    if (interaction.isButton()) {
        if (interaction.customId != 'topup-button') return
            const topupmodal = new Modal()
            .setCustomId('topup-modal')
            .setTitle('topup')
            .addComponents(
                new TextInputComponent()
                .setCustomId('gift-url')
                .setLabel('ลิงก์ซองอั่งเปา')
                .setPlaceholder('')
                .setStyle("SHORT")
                .setRequired(true),
            ) 
            await interaction.showModal(topupmodal)}
    if (interaction.isModalSubmit()) {
        if (interaction.customId != 'topup-modal') return
        const url = interaction.fields.getTextInputValue("gift-url")
        if (!url.startsWith('https://gift.truemoney.com/campaign/?v=')) return interaction.reply({ embeds: [new MessageEmbed().setColor("RED").setDescription(`\`\`\`\nลิงก์ซองอั่งเปาไม่ถูกต้อง\`\`\``).setTimestamp()] ,ephemeral:true })
        tw(config.phone, url).then(redeemed => {
            const topupsuccess = new MessageEmbed()
                    .setColor("GREEN")
                    .setTitle("✅ | เติมเงินสำเร็จ")
                    .setDescription(`\`\`\`cs\n' คุณได้เติมเงินสำเร็จแล้ว จำนวนเงินที่เติม ${redeemed.amount} บาท '\`\`\``)
                    .setFooter({ text: `${interaction.user.tag}` })
            const log = new MessageEmbed()
                .setColor("GREEN")
                .setTitle("มีคนเติมเงิน")
                .setDescription(`<@${interaction.user.id}> เติมเงิน ${redeemed.amount} บาท\nลิงก์ซอง : ${url}`)
                .setFooter({text : `สร้างซองโดย : ${redeemed.owner_full_name}`})
                .setTimestamp()
            webhook.send({username: `${interaction.user.tag}`,avatarURL: `${interaction.user.avatarURL()}`,embeds: [log],});
            interaction.reply({ embeds: [topupsuccess] ,ephemeral:true})
            if (accdata[interaction.user.id]) { 
                accdata[interaction.user.id].point += redeemed.amount;
                accdata[interaction.user.id].pointall += redeemed.amount;
                fs.writeFileSync('./db/acc.json', JSON.stringify(accdata, null, 4));
            } else {
                accdata[interaction.user.id] = {
                    point: redeemed.amount,
                    pointall: redeemed.amount
                }
                fs.writeFileSync('./db/acc.json', JSON.stringify(accdata, null, 4));
            }
            console.log(`redeem ซอง ${redeemed.code} ของ ${redeemed.owner_full_name} จำนวน ${redeemed.amount} บาทแล้ว`) 
        }).catch(err => {
            const topupfaile = new MessageEmbed()
                .setColor("RED")
                .setDescription(`\`\`\`\nเติมเงินไม่สำเร็จ เนื่องจากลิงก์ซองอั่งเปานี้ถูกใช้ไปแล้วหรือลิงก์ซองอั่งเปาไม่ถูกต้อง\`\`\``)
                .setTimestamp();
            interaction.reply({ embeds: [topupfaile] ,ephemeral:true})
        })
  }
 }
)